package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.ShopUserService;
import com.gxwebsoft.shop.entity.ShopUser;
import com.gxwebsoft.shop.param.ShopUserParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户记录表控制器
 *
 * @author 科技小王子
 * @since 2026-02-10 00:37:07
 */
@Tag(name = "用户记录表管理")
@RestController
@RequestMapping("/api/shop/shop-user")
public class ShopUserController extends BaseController {
    @Resource
    private ShopUserService shopUserService;

    @PreAuthorize("hasAuthority('shop:shopUser:list')")
    @Operation(summary = "分页查询用户记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopUser>> page(ShopUserParam param) {
        // 使用关联查询
        return success(shopUserService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopUser:list')")
    @Operation(summary = "查询全部用户记录表")
    @GetMapping()
    public ApiResult<List<ShopUser>> list(ShopUserParam param) {
        // 使用关联查询
        return success(shopUserService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopUser:list')")
    @Operation(summary = "根据id查询用户记录表")
    @GetMapping("/{id}")
    public ApiResult<ShopUser> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(shopUserService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:shopUser:save')")
    @OperationLog
    @Operation(summary = "添加用户记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopUser shopUser) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        // shopUser.setUserId(loginUser.getUserId());
        // }
        if (shopUserService.save(shopUser)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:shopUser:update')")
    @OperationLog
    @Operation(summary = "修改用户记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopUser shopUser) {
        if (shopUserService.updateById(shopUser)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:shopUser:remove')")
    @OperationLog
    @Operation(summary = "删除用户记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopUserService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:shopUser:save')")
    @OperationLog
    @Operation(summary = "批量添加用户记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopUser> list) {
        if (shopUserService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:shopUser:update')")
    @OperationLog
    @Operation(summary = "批量修改用户记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopUser> batchParam) {
        if (batchParam.update(shopUserService, "user_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:shopUser:remove')")
    @OperationLog
    @Operation(summary = "批量删除用户记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopUserService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
